<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="contractId"
          :columns="columns"
          :datasource="datasource"
          v-model:selection="selection"
          tool-class="ele-toolbar-form"
          :scroll="{ x: 800 }"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'createTime'">
              <a-tooltip :title="`${toDateString(record.createTime)}`">
                {{ timeAgo(record.createTime) }}
              </a-tooltip>
            </template>
            <template v-if="column.key === 'needPay'">
              <span v-if="record.payRate && record.totalSettleAmount">{{ (record.payRate / 100 * record.totalSettleAmount).toFixed(2) }}</span>
            </template>
            <template v-if="column.key === 'totalUnReceivableAmount'">
              <p>{{ record.totalSettleAmount - record.totalIncomeAmount }}</p>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openSettle(record)">合同结算设置</a>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <ContractEdit v-model:visible="showEdit" :data="current" @done="reload" />
      <ContractSettle v-model:visible="showSettle" :data="current" @done="reload" />
      <!-- 合同详情弹窗 -->
      <ContractInfo v-model:visible="showInfo" :data="current" @done="reload" />
      <!-- 批量转移弹窗 -->
      <!--    <CustomerMove v-model:visible="showMove" :data="selection" @done="batchMove" />-->
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { computed, createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ExclamationCircleOutlined,
    UserOutlined
  } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { toDateString } from 'ele-admin-pro';
  import Search from './components/search.vue';
  import ContractEdit from './components/contract-edit.vue';
  import ContractSettle from './components/contract-settle.vue';
  import ContractInfo from './components/contract-info.vue';
  import {
    pageContract,
    removeContract,
    removeBatchContract
  } from '@/api/tower/contract';
  import { timeAgo } from 'ele-admin-pro';
  import { useUserStore } from '@/store/modules/user';
  import { Contract, ContractParam } from "@/api/tower/contract/model";

  const userStore = useUserStore();
  // 当前用户信息
  const loginUser = computed(() => userStore.info ?? {});

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Contract[]>([]);
  // 当前编辑数据
  const current = ref<Contract | null>(null);

  // 是否显示资产详情
  const showInfo = ref(false);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageContract({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      key: 'index',
      width: 48,
      align: 'center',
      fixed: 'left',
      hideInSetting: true,
      customRender: ({ index }) => index + (tableRef.value?.tableIndex ?? 0)
    },
    {
      title: '合同编号',
      dataIndex: 'contactNumber',
      key: 'contactNumber'
    },
    {
      title: '项目名称',
      dataIndex: 'projectName'
    },
    {
      title: '预计产值',
      dataIndex: 'contractAmount'
    },
    {
      title: '实际结算金额',
      dataIndex: 'totalSettleAmount'
    },
    {
      title: '实际收款金额',
      dataIndex: 'totalIncomeAmount'
    },
    {
      title: '累计开票金额',
      dataIndex: 'totalInvoicingAmount'
    },
    {
      title: '欠收金额',
      dataIndex: 'totalUnReceivableAmount',
      key: 'totalUnReceivableAmount'
    },
    {
      title: '业务联系人',
      dataIndex: 'customerContact'
    },
    {
      title: '签订日期',
      dataIndex: 'signDate'
    },
    {
      title: '已生成结算次数',
      dataIndex: 'settleNum'
    },
    {
      title: '操作',
      key: 'action',
      width: 200,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ContractParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Contract) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const showSettle = ref<Boolean>(false)
  const openSettle = (row?: Contract) => {
    current.value = row ?? null;
    showSettle.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 打开用户详情弹窗 */
  const openInfo = (row?: Contract) => {
    current.value = row ?? null;
    showInfo.value = true;
  };

  /* 删除单个 */
  const remove = (row: Contract) => {
    const hide = message.loading('请求中..', 0);
    removeContract(row.contractId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量转移 */
  const batchMove = (userId) => {
    console.log(userId, '批量转移0000');
    console.log(selection.value);
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchContract(
          selection.value.map((d) => {
            if (loginUser.value.userId === d.userId) {
              return d.contractId;
            }
          })
        )
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>

<script lang="ts">
  export default {
    name: 'Accessory'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
</style>
